// Translated by Nina
// This source code is under public domain

package net.morilib.deculture.translate;
import net.morilib.automata.lr.ContextFreeGrammar;
import net.morilib.automata.lr.ContextFreeRule;
import net.morilib.deculture.misc.CharacterTerminal;
import net.morilib.deculture.misc.ConstantNonterminal;
import net.morilib.deculture.misc.ConstantTerminal;
import net.morilib.deculture.misc.DecultureException;
import net.morilib.deculture.parser.DecultureDefinition;


public  class ActionConverter   {

	static final int INITIAL = 0;

	private int STATE;
	private int unread = -1;
	private int gotoSymbol = -1;
	private String matched;

private StringBuffer buf = new StringBuffer();
private DecultureDefinition def;
private ContextFreeRule rule;
private StringBuffer num;
private int len;

private void _b(int c) {
	buf.appendCodePoint(c);
}

private void _i() {
	num = new StringBuffer();
}

private void _m(int c) {
	num.appendCodePoint(c);
}

private void _p() {
	Object g;
	String s;
	int x, z;

	x = Integer.valueOf(num.toString());
	z = len - x + 1;
	g = rule.getDerivedSymbol(x - 1);
	if(g instanceof CharacterTerminal) {
		buf.append(String.format("((Character)_refv(%d))", z));
	} else if(g instanceof ConstantTerminal) {
		buf.append(String.format("((%s)_refv(%d))",
				def.getType(((ConstantTerminal)g).getConstant()), z));
	} else if(g == ContextFreeGrammar.ENDMARKER) {
		buf.append(String.format("(_refv(%d))", z));
	} else if(g instanceof ConstantNonterminal) {
		s = ((ConstantNonterminal)g).getConstant();
		s = def.getNonterminalType(s);
		s = s != null ? s : "Object";
		buf.append(String.format("((%s)_refv(%d))", s, z));
	} else {
		throw new DecultureException(g.toString());
	}
}

private void _z() {
	buf.append("$$");
}

public static String translate(ContextFreeRule r, DecultureDefinition d, String s) {
	ActionConverter c = new ActionConverter();

	try {
		c.rule = r;
		c.len = r.getDerivedSymbolLength();
		c.def = d;
		c.parse(new java.io.StringReader(s));
		return c.buf.toString();
	} catch(java.io.IOException e) {
		throw new RuntimeException(e);
	}
}


	private int _read(java.io.Reader rd) throws java.io.IOException {
		int c;

		if(gotoSymbol >= 0) {
			c = gotoSymbol;
			gotoSymbol = -1;
			return c;
		} else if(unread >= 0) {
			c = unread;
			unread = -1;
			return c;
		} else {
			return rd.read();
		}
	}

	void UNGET(int c) {
		unread = c;
	}

	void GOTOSYMBOL(int c) {
		gotoSymbol = c;
	}

	private boolean actionConverter_step(java.io.Reader __rd,
			int  $c) throws java.io.IOException {
		switch(STATE) {
		case 0:
			if($c >= 36 && $c <= 36) {
				STATE = 1;
				return true;
			} else {
				_b($c);
				STATE = 0;
				return true;
			}
		case 1:
			if($c >= 36 && $c <= 36) {
				_z();
				STATE = 0;
				return true;
			} else if($c >= 45 && $c <= 45) {
				STATE = 2;
				return true;
			} else if($c >= 48 && $c <= 57) {
				STATE = 3;
				return true;
			}
			return false;
		case 3:
			if($c >= 48 && $c <= 57) {
				STATE = 3;
				return true;
			} else {
				_p();UNGET($c);
				STATE = 0;
				return true;
			}
		case 2:
			if($c >= 48 && $c <= 57) {
				STATE = 3;
				return true;
			}
			return false;
		}
		return false;
	}
	private boolean actionConverter_accepted() {
		return (STATE == 0);
	}

	private boolean actionConverter_execaction(int  $c) {
		switch(STATE) {
		case 1:
			_i();
			break;
		case 0:
			break;
		case 2:
			_m($c);
			break;
		case 3:
			_m($c);
			break;
		}
		return true;
	}

	private boolean actionConverter_isend() {
		return false;
	}

	void actionConverter_parse(java.io.Reader rd,
			int x) throws java.io.IOException {
		boolean b = false;
		int c = x;

		b = actionConverter_accepted();
		if(rd == null) {
			throw new RuntimeException("can not recurse");
		} else if(!actionConverter_execaction(-2)) {
			if(!b)  throw new RuntimeException();
		}

		do {
			if(actionConverter_step(rd, c)) {
				b = actionConverter_accepted() || b;
				if(!actionConverter_execaction(c))  break;
			} else if(b) {
				UNGET(c);
				return;
			} else {
				throw new RuntimeException();
			}
		} while((c = _read(rd)) >= 0);
		if(!b)  throw new RuntimeException();
	}

	public boolean matches(String s) {
		int n;

		try {
			STATE = 0;  matched = null;
			for(n = 0; n < s.length(); n++) {
				if(!actionConverter_step(null, s.charAt(n))) {
					return false;
				}
			}
		} catch(java.io.IOException e) {
			throw new RuntimeException(e);
		}

		if(actionConverter_accepted()) {
			matched = s;
			return true;
		} else {
			return false;
		}
	}

	public boolean lookingAt(String s) {
		StringBuffer b = new StringBuffer();
		int n;

		try {
			STATE = 0;  matched = null;
			for(n = 0; n < s.length(); n++) {
				if(actionConverter_accepted()) {
					matched = b.toString();
				}
	
				if(actionConverter_step(null, s.charAt(n))) {
					// do nothing
				} else {
					return matched != null;
				}
				b.append(s.charAt(n));
			}
		} catch(java.io.IOException e) {
			throw new RuntimeException(e);
		}

		if(actionConverter_accepted()) {
			matched = b.toString();
			return true;
		} else {
			return matched != null;
		}
	}

	public boolean find(String s) {
		StringBuffer b;
		int n, k;

		try {
			STATE = 0;  matched = null;
			for(k = 0; k < s.length(); k++) {
				b = new StringBuffer();
				for(n = k; n < s.length(); n++) {
					if(actionConverter_accepted()) {
						matched = b.toString();
					}
	
					if(actionConverter_step(null, s.charAt(n))) {
						// do noting
					} else if(matched == null) {
						break;
					} else {
						return true;
					}
					b.append(s.charAt(n));
				}
	
				if(actionConverter_accepted()) {
					matched = b.toString();
					return true;
				} else if(matched != null) {
					return true;
				} else {
					STATE = 0;
				}
			}
			return false;
		} catch(java.io.IOException e) {
			throw new RuntimeException(e);
		}
	}

	public String group() {
		return matched;
	}

	public boolean parse(
			java.io.Reader rd) throws java.io.IOException {
		int c;

		if(!actionConverter_execaction(-2))  return actionConverter_accepted();
		while((c = _read(rd)) >= 0 || actionConverter_isend()) {
			if(!actionConverter_step(rd, c)) {
				throw new RuntimeException();
			} else if(!actionConverter_execaction(c)) {
				return actionConverter_accepted();
			}
		}
		return actionConverter_accepted();
	}

	public boolean parse(
			java.io.InputStream rd) throws java.io.IOException {
		return parse(new java.io.InputStreamReader(rd));
	}

	public static boolean parseAll(
			java.io.Reader rd) throws java.io.IOException {
		ActionConverter o = new ActionConverter();

		return o.parse(rd);
	}

	public static boolean parseAll(
			java.io.InputStream rd) throws java.io.IOException {
		return parseAll(new java.io.InputStreamReader(rd));
	}

}
